Bug 507727 - setuid/setgid programs execed by straced process don't change user/group
setuid/setgid programs execed by straced process don't change user/group
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
11
All Linux
low Severity medium
: ---
: ---
Assigned To: Kernel Maintainer List
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-06-23 17:58 EDT by Orion Poplawski
Modified: 2010-06-28 09:15 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-06-28 09:15:57 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Orion Poplawski 2009-06-23 17:58:13 EDT
Description of problem:

I'm trying to trace a problem in a program than spawns sendmail.  Unfortunately, sendmail needs to run setgid smmsp, but I get the following:

WARNING: RunAsUser for MSP ignored, check group ids (egid=6, want=51)

because when run under strace, it doens't change the egid.

I'm running the following command:

/usr/sbin/setuidstrace -f -o amreport.strace su amandabackup -c '/usr/sbin/amreport Offsite -l /var/lib/amanda/Offsite/log.20090620110551.0'

# ls -ld /usr/sbin/setuidstrace
-rwsr-sr-x. 1 root root 294440 2009-06-23 15:34 /usr/sbin/setuidstrace

Unfortunately, amreport has to be run with the proper uid/gid combo as well.

Version-Release number of selected component (if applicable):
strace-4.5.18-2.fc11.x86_64
Comment 1 Denys Vlasenko 2009-07-07 10:18:14 EDT
Not a bug.

If user would be able to ptrace setuid program and still have it change its uid, then user can alter this program's behavior. As in: "overwrite /etc/passwd".

This would be a security breach.
Comment 2 Orion Poplawski 2009-07-07 10:33:27 EDT
I'm not talking about any user running strace, just root, which I guess I didn't state above.  The first setuid/gid works, but if it spawns a second setuid/gid program, that doesn't work.
Comment 3 Denys Vlasenko 2009-07-09 09:56:43 EDT
I think it's possible to relax the restriction that kernel ignores setuig/gid bits in execve if process is ptraced: if we can see that tracer process is privileged enough, then we can allow it.

If this is acceptable at all, it is to be done in kernel code, not in strace.
Comment 4 Andreas Schwab 2009-08-05 06:18:24 EDT
This needs to be fixed in the kernel.
Comment 5 Bug Zapper 2010-04-27 11:12:57 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 6 Bug Zapper 2010-06-28 09:15:57 EDT
Fedora 11 changed to end-of-life (EOL) status on 2010-06-25. Fedora 11 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.